CWIS Developer Documentation

- Home
- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

List of all members
ApplicationFramework Class Reference

Top-level framework for web applications. More...

## Application Framework
const | LOGLVL_TRACE = 6
| TRACE error logging level.
const | LOGLVL_DEBUG = 5
| DEBUG error logging leve.
const | LOGLVL_INFO = 4
| INFO error logging level.
const | LOGLVL_WARNING = 3
| WARNING error logging level.
const | LOGLVL_ERROR = 2
| ERROR error logging level.
const | LOGLVL_FATAL = 1
| FATAL error logging level.
static | AddObjectDirectory ($Dir, $Prefix="", $ClassPattern=NULL, $ClassReplacement=NULL)
| Add directory to be searched for object files when autoloading.
static | SessionLifetime ($NewValue=NULL)
| Get/set session timeout in seconds.
| AddImageDirectories ($Dir, $SearchLast=FALSE, $SkipSlashCheck=FALSE)
| Add additional directory(s) to be searched for image files.
| AddIncludeDirectories ($Dir, $SearchLast=FALSE, $SkipSlashCheck=FALSE)
| Add additional directory(s) to be searched for user interface include (CSS, JavaScript, common PHP, common HTML, etc) files.
| AddInterfaceDirectories ($Dir, $SearchLast=FALSE, $SkipSlashCheck=FALSE)
| Add additional directory(s) to be searched for user interface (HTML/TPL) files.
| AddFunctionDirectories ($Dir, $SearchLast=FALSE, $SkipSlashCheck=FALSE)
| Add additional directory(s) to be searched for function ("F-") files.
| SetBrowserDetectionFunc ($DetectionFunc)
| Specify function to use to detect the web browser type.
| AddUnbufferedCallback ($Callback, $Parameters=array())
| Add a callback that will not be executed after buffered content has been output and that won't have its output buffered.
| TemplateLocationCacheExpirationInterval ($NewInterval=-1)
| Get/set UI template location cache expiration period in minutes.
| LoadPage ($PageName)
| Load page PHP and HTML/TPL files.
| GetPageName ()
| Get name of page being loaded.
| SetJumpToPage ($Page)
| Set URL of page to autoload after PHP page file is executed.
| JumpToPageIsSet ()
| Report whether a page to autoload has been set.
| HtmlCharset ($NewSetting=NULL)
| Get/set HTTP character encoding value.
| SuppressHTMLOutput ($NewSetting=TRUE)
| Suppress loading of HTML files.
| ActiveUserInterface ($UIName=NULL)
| Get/set name of current active user interface.
| GetUserInterfaces ()
| Get the list of available user interfaces.
| AddPostProcessingCall ($FunctionName, &$Arg1=self::NOVALUE, &$Arg2=self::NOVALUE, &$Arg3=self::NOVALUE, &$Arg4=self::NOVALUE, &$Arg5=self::NOVALUE, &$Arg6=self::NOVALUE, &$Arg7=self::NOVALUE, &$Arg8=self::NOVALUE, &$Arg9=self::NOVALUE)
| Add function to be called after HTML has been loaded.
| AddEnvInclude ($FileName)
| Add file to be included to set up environment.
| GUIFile ($FileName)
| Search UI directories for specified image or CSS file and return name of correct file.
| PUIFile ($FileName)
| Search UI directories for specified image or CSS file and print name of correct file.
| RequireUIFile ($FileName)
| Add file to list of required UI files.
| LoadFunction ($Callback)
| Attempt to load code for function or method if not currently available.
| GetElapsedExecutionTime ()
| Get time elapsed since constructor was called.
| GetSecondsBeforeTimeout ()
| Get remaining available (PHP) execution time.
| HtaccessSupport ()
| Determine if .htaccess files are enabled.
| LogError ($Level, $Msg)
| Write error message to log.
| LogMessage ($Level, $Msg)
| Write status message to log.
| LoggingLevel ($NewValue=NULL)
| Get/set logging level.

## Event Handling
const | EVENTTYPE_DEFAULT = 1
| Default event type.
const | EVENTTYPE_CHAIN = 2
| Result chaining event type.
const | EVENTTYPE_FIRST = 3
| First response event type.
const | EVENTTYPE_NAMED = 4
| Named result event type.
const | ORDER_FIRST = 1
| Run hooked function first (i.e.
const | ORDER_MIDDLE = 2
| Run hooked function after ORDER_FIRST and before ORDER_LAST events.
const | ORDER_LAST = 3
| Run hooked function last (i.e.
| RegisterEvent ($EventsOrEventName, $EventType=NULL)
| Register one or more events that may be signaled.
| IsRegisteredEvent ($EventName)
| Check if event has been registered (is available to be signaled).
| HookEvent ($EventsOrEventName, $Callback=NULL, $Order=self::ORDER_MIDDLE)
| Hook one or more functions to be called when the specified event is signaled.
| SignalEvent ($EventName, $Parameters=NULL)
| Signal that an event has occured.
| IsStaticOnlyEvent ($EventName)
| Report whether specified event only allows static callbacks.

## Task Management
const | PRIORITY_HIGH = 1
| Highest priority.
const | PRIORITY_MEDIUM = 2
| Medium (default) priority.
const | PRIORITY_LOW = 3
| Lower priority.
const | PRIORITY_BACKGROUND = 4
| Lowest priority.
| QueueTask ($Callback, $Parameters=NULL, $Priority=self::PRIORITY_MEDIUM, $Description="")
| Add task to queue.
| QueueUniqueTask ($Callback, $Parameters=NULL, $Priority=self::PRIORITY_MEDIUM, $Description="")
| Add task to queue if not already in queue or currently running.
| TaskIsInQueue ($Callback, $Parameters=NULL)
| Check if task is already in queue or currently running.
| GetTaskQueueSize ($Priority=NULL)
| Retrieve current number of tasks in queue.
| GetQueuedTaskList ($Count=100, $Offset=0)
| Retrieve list of tasks currently in queue.
| GetRunningTaskList ($Count=100, $Offset=0)
| Retrieve list of tasks currently in queue.
| GetOrphanedTaskList ($Count=100, $Offset=0)
| Retrieve list of tasks currently in queue.
| GetOrphanedTaskCount ()
| Retrieve current number of orphaned tasks.
| ReQueueOrphanedTask ($TaskId, $NewPriority=NULL)
| Move orphaned task back into queue.
| DeleteTask ($TaskId)
| Remove task from task queues.
| GetTask ($TaskId)
| Retrieve task info from queue (either running or queued tasks).
| TaskExecutionEnabled ($NewValue=NULL)
| Get/set whether automatic task execution is enabled.
| MaxTasks ($NewValue=NULL)
| Get/set maximum number of tasks to have running simultaneously.
| MaxExecutionTime ($NewValue=NULL)
| Get/set maximum PHP execution time.
| FindCommonTemplate ($BaseName)
| Preserved for backward compatibility for use with code written prior to October 2012.

## Backward Compatibility
const | NOVALUE = ".-+-.NO VALUE PASSED IN FOR ARGUMENT.-+-."
| OnCrash ()
| Called automatically at program termination to ensure output is written out.

## Detailed Description

Top-level framework for web applications.

Definition at line 15 of file ApplicationFramework.php.

## Member Function Documentation

ApplicationFramework::ActiveUserInterface | ( |  | $UIName = `NULL` | ) |

Get/set name of current active user interface.

Any "SPTUI&ndash;" prefix is stripped out for backward compatibility in CWIS.

Parameters

  string | $UIName | Name of new active user interface. (OPTIONAL)

Returns
  Name of currently active user interface.

Definition at line 676 of file ApplicationFramework.php.

ApplicationFramework::AddEnvInclude | ( |  | $FileName | ) |

Add file to be included to set up environment.

This file is loaded right before the PHP file.

Parameters

  string | $FileName | Name of file to be included.

Definition at line 778 of file ApplicationFramework.php.

ApplicationFramework::AddFunctionDirectories | ( |  | $Dir,
|  |  | $SearchLast = `FALSE`,
|  |  | $SkipSlashCheck = `FALSE`
| ) |  |

Add additional directory(s) to be searched for function ("F-") files.

Specified directory(s) will be searched, in order, before the default directories or any other directories previously specified. If a directory is already present in the list, it will be moved to front to be searched first (or to the end to be searched last, if SearchLast is set). SearchLast only affects whether added directories are searched before or after those currently in the list; when multiple directories are added, they are always searched in the order they appear in the array. The token "%ACTIVEUI%" may be included in the directory names, and will be replaced with the canonical name of the currently active UI when searching for files.

Parameters

  string | $Dir | String with directory or array with directories to be searched.
  bool | $SearchLast | If TRUE, the directory(s) are searched after the entries current in the list, instead of before. (OPTIONAL, defaults to FALSE)
  bool | $SkipSlashCheck | If TRUE, check for trailing slash will be omitted. (OPTIONAL, defaults to FALSE)

See Also
  ApplicationFramework::GUIFile()
  ApplicationFramework::PUIFile()

Definition at line 250 of file ApplicationFramework.php.

ApplicationFramework::AddImageDirectories | ( |  | $Dir,
|  |  | $SearchLast = `FALSE`,
|  |  | $SkipSlashCheck = `FALSE`
| ) |  |

Add additional directory(s) to be searched for image files.

Specified directory(s) will be searched, in order, before the default directories or any other directories previously specified. If a directory is already present in the list, it will be moved to front to be searched first (or to the end to be searched last, if SearchLast is set). SearchLast only affects whether added directories are searched before or after those currently in the list; when multiple directories are added, they are always searched in the order they appear in the array. The token "%ACTIVEUI%" may be included in the directory names, and will be replaced with the canonical name of the currently active UI when searching for files.

Parameters

  string | $Dir | String with directory or array with directories to be searched.
  bool | $SearchLast | If TRUE, the directory(s) are searched after the entries current in the list, instead of before. (OPTIONAL, defaults to FALSE)
  bool | $SkipSlashCheck | If TRUE, check for trailing slash will be omitted. (OPTIONAL, defaults to FALSE)

See Also
  ApplicationFramework::GUIFile()
  ApplicationFramework::PUIFile()

Definition at line 171 of file ApplicationFramework.php.

ApplicationFramework::AddIncludeDirectories | ( |  | $Dir,
|  |  | $SearchLast = `FALSE`,
|  |  | $SkipSlashCheck = `FALSE`
| ) |  |

Add additional directory(s) to be searched for user interface include (CSS, JavaScript, common PHP, common HTML, etc) files.

Specified directory(s) will be searched, in order, before the default directories or any other directories previously specified. If a directory is already present in the list, it will be moved to front to be searched first (or to the end to be searched last, if SearchLast is set). SearchLast only affects whether added directories are searched before or after those currently in the list; when multiple directories are added, they are always searched in the order they appear in the array. The token "%ACTIVEUI%" may be included in the directory names, and will be replaced with the canonical name of the currently active UI when searching for files.

Parameters

  string | $Dir | String with directory or array with directories to be searched.
  bool | $SearchLast | If TRUE, the directory(s) are searched after the entries current in the list, instead of before. (OPTIONAL, defaults to FALSE)
  bool | $SkipSlashCheck | If TRUE, check for trailing slash will be omitted. (OPTIONAL, defaults to FALSE)

See Also
  ApplicationFramework::GUIFile()
  ApplicationFramework::PUIFile()

Definition at line 198 of file ApplicationFramework.php.

ApplicationFramework::AddInterfaceDirectories | ( |  | $Dir,
|  |  | $SearchLast = `FALSE`,
|  |  | $SkipSlashCheck = `FALSE`
| ) |  |

Add additional directory(s) to be searched for user interface (HTML/TPL) files.

Specified directory(s) will be searched, in order, before the default directories or any other directories previously specified. If a directory is already present in the list, it will be moved to front to be searched first (or to the end to be searched last, if SearchLast is set). SearchLast only affects whether added directories are searched before or after those currently in the list; when multiple directories are added, they are always searched in the order they appear in the array. The token "%ACTIVEUI%" may be included in the directory names, and will be replaced with the canonical name of the currently active UI when searching for files.

Parameters

  string | $Dir | String with directory or array with directories to be searched.
  bool | $SearchLast | If TRUE, the directory(s) are searched after the entries current in the list, instead of before. (OPTIONAL, defaults to FALSE)
  bool | $SkipSlashCheck | If TRUE, check for trailing slash will be omitted. (OPTIONAL, defaults to FALSE)

See Also
  ApplicationFramework::GUIFile()
  ApplicationFramework::PUIFile()

Definition at line 224 of file ApplicationFramework.php.

static ApplicationFramework::AddObjectDirectory | ( |  | $Dir,
|  |  | $Prefix = `""`,
|  |  | $ClassPattern = `NULL`,
|  |  | $ClassReplacement = `NULL`
| ) |  |
| static

Add directory to be searched for object files when autoloading.

Directories are searched in the order they are added.

Parameters

  string | Dir Directory to be searched.
  string | Prefix Leading prefix to be stripped from file names when comparing them against objects (e.g. "Axis&ndash;"). (OPTIONAL)
  string|array | ClassPattern Pattern string or array of pattern strings to run on class name via preg_replace(). (OPTIONAL)
  string|array | ClassReplacement Replacement string or array of replacement strings to run on class name via preg_replace(). (OPTIONAL)

Definition at line 136 of file ApplicationFramework.php.

Referenced by PluginManager\LoadPlugins().

Here is the caller graph for this function:

ApplicationFramework::AddPostProcessingCall | ( |  | $FunctionName,
|  | & | $Arg1 = `self::NOVALUE`,
|  | & | $Arg2 = `self::NOVALUE`,
|  | & | $Arg3 = `self::NOVALUE`,
|  | & | $Arg4 = `self::NOVALUE`,
|  | & | $Arg5 = `self::NOVALUE`,
|  | & | $Arg6 = `self::NOVALUE`,
|  | & | $Arg7 = `self::NOVALUE`,
|  | & | $Arg8 = `self::NOVALUE`,
|  | & | $Arg9 = `self::NOVALUE`
| ) |  |

Add function to be called after HTML has been loaded.

The arguments are optional and are saved as references so that any changes to their value that occured while loading the HTML will be recognized.

Parameters

  string | $FunctionName | Name of function to be called.
  mixed | $Arg1 | First argument to be passed to function. (OPTIONAL, REFERENCE)
  mixed | $Arg2 | Second argument to be passed to function. (OPTIONAL, REFERENCE)
  mixed | $Arg3 | Third argument to be passed to function. (OPTIONAL, REFERENCE)
  mixed | $Arg4 | Fourth argument to be passed to function. (OPTIONAL, REFERENCE)
  mixed | $Arg5 | FifthFirst argument to be passed to function. (OPTIONAL, REFERENCE)
  mixed | $Arg6 | Sixth argument to be passed to function. (OPTIONAL, REFERENCE)
  mixed | $Arg7 | Seventh argument to be passed to function. (OPTIONAL, REFERENCE)
  mixed | $Arg8 | Eighth argument to be passed to function. (OPTIONAL, REFERENCE)
  mixed | $Arg9 | Ninth argument to be passed to function. (OPTIONAL, REFERENCE)

Definition at line 756 of file ApplicationFramework.php.

ApplicationFramework::AddUnbufferedCallback | ( |  | $Callback,
|  |  | $Parameters = `array()`
| ) |  |

Add a callback that will not be executed after buffered content has been output and that won't have its output buffered.

Parameters

  $Callback | callback
  $Parameters | optional callback parameters in an array

Definition at line 273 of file ApplicationFramework.php.

ApplicationFramework::DeleteTask | ( |  | $TaskId | ) |

Remove task from task queues.

Parameters

  int | $TaskId | Task ID.

Definition at line 1519 of file ApplicationFramework.php.

ApplicationFramework::FindCommonTemplate | ( |  | $BaseName | ) |

Preserved for backward compatibility for use with code written prior to October 2012.

Definition at line 1640 of file ApplicationFramework.php.

ApplicationFramework::GetElapsedExecutionTime | ( |  | ) |

Get time elapsed since constructor was called.

Returns
  Elapsed execution time in seconds (as a float).

Definition at line 889 of file ApplicationFramework.php.

Referenced by GetSecondsBeforeTimeout().

Here is the caller graph for this function:

ApplicationFramework::GetOrphanedTaskCount | ( |  | ) |

Retrieve current number of orphaned tasks.

Returns
  Number of orphaned tasks.

Definition at line 1484 of file ApplicationFramework.php.

ApplicationFramework::GetOrphanedTaskList | ( |  | $Count = `100`,
|  |  | $Offset = `0`
| ) |  |

Retrieve list of tasks currently in queue.

Parameters

  int | $Count | Number to retrieve. (OPTIONAL, defaults to 100)
  int | $Offset | Offset into queue to start retrieval. (OPTIONAL)

Returns
  Array with task IDs for index and task info for values. Task info is stored as associative array with "Callback" and "Parameter" indices.

Definition at line 1472 of file ApplicationFramework.php.

ApplicationFramework::GetPageName | ( |  | ) |

Get name of page being loaded.

The page name will not include an extension. This call is only meaningful once LoadPage() has been called.

Returns
  Page name.

Definition at line 606 of file ApplicationFramework.php.

ApplicationFramework::GetQueuedTaskList | ( |  | $Count = `100`,
|  |  | $Offset = `0`
| ) |  |

Retrieve list of tasks currently in queue.

Parameters

  int | $Count | Number to retrieve. (OPTIONAL, defaults to 100)
  int | $Offset | Offset into queue to start retrieval. (OPTIONAL)

Returns
  Array with task IDs for index and task info for values. Task info is stored as associative array with "Callback" and "Parameter" indices.

Definition at line 1444 of file ApplicationFramework.php.

ApplicationFramework::GetRunningTaskList | ( |  | $Count = `100`,
|  |  | $Offset = `0`
| ) |  |

Retrieve list of tasks currently in queue.

Parameters

  int | $Count | Number to retrieve. (OPTIONAL, defaults to 100)
  int | $Offset | Offset into queue to start retrieval. (OPTIONAL)

Returns
  Array with task IDs for index and task info for values. Task info is stored as associative array with "Callback" and "Parameter" indices.

Definition at line 1457 of file ApplicationFramework.php.

ApplicationFramework::GetSecondsBeforeTimeout | ( |  | ) |

Get remaining available (PHP) execution time.

Returns
  Number of seconds remaining before script times out (as a float).

Definition at line 898 of file ApplicationFramework.php.

References GetElapsedExecutionTime().

ApplicationFramework::GetTask | ( |  | $TaskId | ) |

Retrieve task info from queue (either running or queued tasks).

Parameters

  int | $TaskId | Task ID.

Returns
  Array with task info for values or NULL if task is not found. Task info is stored as associative array with "Callback" and "Parameter" indices.

Definition at line 1532 of file ApplicationFramework.php.

ApplicationFramework::GetTaskQueueSize | ( |  | $Priority = `NULL` | ) |

Retrieve current number of tasks in queue.

Parameters

  int | $Priority | of tasks. (OPTIONAL, defaults to all priorities)

Returns
  Number of tasks currently in queue.

Definition at line 1430 of file ApplicationFramework.php.

ApplicationFramework::GetUserInterfaces | ( |  | ) |

Get the list of available user interfaces.

The result contains a map of interface paths to interface labels.

Returns
  array list of users interfaces (interface path => label)

Definition at line 690 of file ApplicationFramework.php.

ApplicationFramework::GUIFile | ( |  | $FileName | ) |

Search UI directories for specified image or CSS file and return name of correct file.

Parameters

  string | $FileName | Base file name.

Returns
  Full relative path name of file or NULL if file not found.

Definition at line 789 of file ApplicationFramework.php.

Referenced by LoadPage(), and PUIFile().

Here is the caller graph for this function:

ApplicationFramework::HookEvent | ( |  | $EventsOrEventName,
|  |  | $Callback = `NULL`,
|  |  | $Order = `self::ORDER_MIDDLE`
| ) |  |

Hook one or more functions to be called when the specified event is signaled.

The callback parameter is of the PHP type "callback", which allows object methods to be passed.

Parameters

  array | string | $EventsOrEventName | Name of the event to hook. To hook multiple events, this may also be an array, with the event names as the index and the callbacks as the values.
  callback | $Callback | Function to be called when event is signaled. (OPTIONAL if EventsOrEventName is an array of events)
  int | $Order | Preference for when function should be called, primarily for CHAIN and FIRST events. (OPTIONAL, defaults to ORDER_MIDDLE)

Returns
  TRUE if all callbacks were successfully hooked, otherwise FALSE.

Definition at line 1169 of file ApplicationFramework.php.

ApplicationFramework::HtaccessSupport | ( |  | ) |

Determine if .htaccess files are enabled.

Returns
  TRUE if .htaccess files are enabled or FALSE otherwise

Definition at line 907 of file ApplicationFramework.php.

ApplicationFramework::HtmlCharset | ( |  | $NewSetting = `NULL` | ) |

Get/set HTTP character encoding value.

This is set for the HTTP header and may be queried and set in the HTML header by the active user interface. The default charset is UTF-8. A list of valid character set values can be found at http://www.iana.org/assignments/character-sets

Parameters

  string | $NewSetting | New character encoding value string (e.g. "ISO-8859-1").

Returns
  Current character encoding value.

Definition at line 653 of file ApplicationFramework.php.

Referenced by LoadPage().

Here is the caller graph for this function:

ApplicationFramework::IsRegisteredEvent | ( |  | $EventName | ) |

Check if event has been registered (is available to be signaled).

Parameters

  string | $EventName | Name of event (string).

Returns
  TRUE if event is registered, otherwise FALSE.

Definition at line 1150 of file ApplicationFramework.php.

ApplicationFramework::IsStaticOnlyEvent | ( |  | $EventName | ) |

Report whether specified event only allows static callbacks.

Parameters

  string | $EventName | Name of event to check.

Returns
  TRUE if specified event only allows static callbacks, otherwise FALSE.

Definition at line 1312 of file ApplicationFramework.php.

ApplicationFramework::JumpToPageIsSet | ( |  | ) |

Report whether a page to autoload has been set.

Returns
  TRUE if page is set to autoload, otherwise FALSE.

Definition at line 639 of file ApplicationFramework.php.

ApplicationFramework::LoadFunction | ( |  | $Callback | ) |

Attempt to load code for function or method if not currently available.

Function code to be loaded should be located in a file named "F-XXX.php", where "XXX" is the function name. The file may reside in "local/include", any of the interface "include" directories, or any of the object directories.

Parameters

  callback | $Callback | Function or method info.

Returns
  TRUE if function/method is now available, else FALSE.

Definition at line 840 of file ApplicationFramework.php.

References LogError().

ApplicationFramework::LoadPage | ( |  | $PageName | ) |

Load page PHP and HTML/TPL files.

Parameters

  PageName | Name of page to be loaded (e.g. "BrowseResources").

Definition at line 317 of file ApplicationFramework.php.

References GUIFile(), HtmlCharset(), PHP, and SignalEvent().

ApplicationFramework::LogError | ( |  | $Level,
|  |  | $Msg
| ) |  |

Write error message to log.

The difference between this and LogMessage is the way that an inability to write to the log is handled.

Parameters

  Level | Current message logging must be at or above specified level for error message to be written. (See LoggingLevel() for definitions of the error logging levels.)
  Msg | Error message text.

Returns
  TRUE if message was logged, otherwise FALSE.

See Also
  LoggingLevel
  LogMessage

Definition at line 924 of file ApplicationFramework.php.

References LogMessage().

Referenced by LoadFunction(), and SignalEvent().

Here is the caller graph for this function:

ApplicationFramework::LoggingLevel | ( |  | $NewValue = `NULL` | ) |

Get/set logging level.

Status and error messages are only written if their associated level is at or below this value. The six levels of log messages are, in increasing level of severity: 6: TRACE - Very detailed logging, usually only used when attempting to diagnose a problem in one specific section of code. 5: DEBUG - Information that is diagnostically helpful when debugging. 4: INFO - Generally-useful information, that may come in handy but to which little attention is normally paid. (This should not be used for events that routinely occur with every page load.) 3: WARNING - An event that may potentially cause problems, but is automatically recovered from. 2: ERROR - Any error which is fatal to the operation currently being performed, but does not result in overall application shutdown or persistent data corruption. 1: FATAL - Any error which results in overall application shutdown or persistent data corruption.

Parameters

  int | $NewValue | New error logging level. (OPTIONAL)

Returns
  Current error logging level.

See Also
  ApplicationFramework::LogError()

Definition at line 1033 of file ApplicationFramework.php.

ApplicationFramework::LogMessage | ( |  | $Level,
|  |  | $Msg
| ) |  |

Write status message to log.

The difference between this and LogError is the way that an inability to write to the log is handled.

Parameters

  int | $Level | Current message logging must be at or above specified level for message to be written. (See LoggingLevel() for definitions of the error logging levels.)
  string | $Msg | Message text.

Returns
  TRUE if message was logged, otherwise FALSE.

See Also
  ApplicationFramework::LoggingLevel()
  ApplicationFramework::LogError()

Definition at line 965 of file ApplicationFramework.php.

Referenced by LogError().

Here is the caller graph for this function:

ApplicationFramework::MaxExecutionTime | ( |  | $NewValue = `NULL` | ) |

Get/set maximum PHP execution time.

Setting a new value is not possible if PHP is running in safe mode.

Parameters

  int | $NewValue | New setting for max execution time in seconds. (OPTIONAL, but minimum value is 5 if specified)

Returns
  Current max execution time in seconds.

Definition at line 1615 of file ApplicationFramework.php.

ApplicationFramework::MaxTasks | ( |  | $NewValue = `NULL` | ) |

Get/set maximum number of tasks to have running simultaneously.

Parameters

  int | $NewValue | New setting for max number of tasks. (OPTIONAL)

Returns
  Current maximum number of tasks to run at once.

Definition at line 1597 of file ApplicationFramework.php.

ApplicationFramework::OnCrash | ( |  | ) |

Called automatically at program termination to ensure output is written out.

(Not intended to be called directly, could not be made private to class because of automatic execution method.)

Definition at line 2256 of file ApplicationFramework.php.

References PHP.

ApplicationFramework::PUIFile | ( |  | $FileName | ) |

Search UI directories for specified image or CSS file and print name of correct file.

If the file is not found, nothing is printed.

This is intended to be called from within interface HTML files to ensure that the correct file is loaded, regardless of which interface it is in.

Parameters

  string | $FileName | Base file name.

Definition at line 814 of file ApplicationFramework.php.

References GUIFile().

ApplicationFramework::QueueTask | ( |  | $Callback,
|  |  | $Parameters = `NULL`,
|  |  | $Priority = `self::PRIORITY_MEDIUM`,
|  |  | $Description = `""`
| ) |  |

Add task to queue.

The Callback parameters is the PHP "callback" type. If $Callback refers to a function (rather than an object method) that function must be available in a global scope on all pages or must be loadable by ApplicationFramework::LoadFunction().

Parameters

  callback | $Callback | Function or method to call to perform task.
  array | $Parameters | Array containing parameters to pass to function or method. (OPTIONAL, pass NULL for no parameters)
  int | $Priority | Priority to assign to task. (OPTIONAL, defaults to PRIORITY_MEDIUM)
  string | $Description | Text description of task. (OPTIONAL)

Definition at line 1344 of file ApplicationFramework.php.

Referenced by QueueUniqueTask().

Here is the caller graph for this function:

ApplicationFramework::QueueUniqueTask | ( |  | $Callback,
|  |  | $Parameters = `NULL`,
|  |  | $Priority = `self::PRIORITY_MEDIUM`,
|  |  | $Description = `""`
| ) |  |

Add task to queue if not already in queue or currently running.

If task is already in queue with a lower priority than specified, the task's priority will be increased to the new value. The Callback parameter is the PHP "callback" type. If $Callback refers to a function (rather than an object method) that function must be available in a global scope on all pages or must be loadable by ApplicationFramework::LoadFunction().

Parameters

  callback | $Callback | Function or method to call to perform task.
  array | $Parameters | Array containing parameters to pass to function or method. (OPTIONAL, pass NULL for no parameters)
  int | $Priority | Priority to assign to task. (OPTIONAL, defaults to PRIORITY_MEDIUM)
  string | $Description | Text description of task. (OPTIONAL)

Returns
  TRUE if task was added, otherwise FALSE.

See Also
  ApplicationFramework::TaskIsInQueue()

Definition at line 1373 of file ApplicationFramework.php.

References QueueTask(), and TaskIsInQueue().

ApplicationFramework::RegisterEvent | ( |  | $EventsOrEventName,
|  |  | $EventType = `NULL`
| ) |  |

Register one or more events that may be signaled.

Parameters

  array | string | $EventsOrEventName | Name of event (string). To register multiple events, this may also be an array, with the event names as the index and the event types as the values.
  int | $EventType | Type of event (constant). (OPTIONAL if EventsOrEventName is an array of events)

Definition at line 1130 of file ApplicationFramework.php.

ApplicationFramework::ReQueueOrphanedTask | ( |  | $TaskId,
|  |  | $NewPriority = `NULL`
| ) |  |

Move orphaned task back into queue.

Parameters

  int | $TaskId | Task ID.
  int | $NewPriority | New priority for task being requeued. (OPTIONAL)

Definition at line 1497 of file ApplicationFramework.php.

ApplicationFramework::RequireUIFile | ( |  | $FileName | ) |

Add file to list of required UI files.

This is used to make sure a particular JavaScript or CSS file is loaded. Only files loaded with ApplicationFramework::GUIFile() or ApplicationFramework::PUIFile() are considered when deciding if a file has already been loaded.

Parameters

  string | $FileName | Base name (without path) of required file.

Definition at line 827 of file ApplicationFramework.php.

static ApplicationFramework::SessionLifetime | ( |  | $NewValue = `NULL` | ) |
| static

Get/set session timeout in seconds.

Parameters

  int | $NewValue | New session timeout value. (OPTIONAL)

Returns
  Current session timeout value in seconds.

Definition at line 304 of file ApplicationFramework.php.

ApplicationFramework::SetBrowserDetectionFunc | ( |  | $DetectionFunc | ) |

Specify function to use to detect the web browser type.

Function should return an array of browser names.

Parameters

  callback | $DetectionFunc | Browser detection function callback.

Definition at line 262 of file ApplicationFramework.php.

ApplicationFramework::SetJumpToPage | ( |  | $Page | ) |

Set URL of page to autoload after PHP page file is executed.

The HTML/TPL file will never be loaded if this is set. Pass in NULL to clear any autoloading.

Parameters

  Page | URL of page to jump to (autoload). If the URL does not appear to point to a PHP or HTML file then "index.php?P=" will be prepended to it.

Definition at line 617 of file ApplicationFramework.php.

ApplicationFramework::SignalEvent | ( |  | $EventName,
|  |  | $Parameters = `NULL`
| ) |  |

Signal that an event has occured.

Parameters

  string | $EventName | Name of event being signaled.
  array | $Parameters | Associative array of parameters for event, with CamelCase parameter names as indexes. (OPTIONAL)

Returns
  Appropriate return value for event type. Returns NULL if no event with specified name was registered and for EVENTTYPE_DEFAULT events.

Definition at line 1230 of file ApplicationFramework.php.

References LogError().

Referenced by LoadPage().

Here is the caller graph for this function:

ApplicationFramework::SuppressHTMLOutput | ( |  | $NewSetting = `TRUE` | ) |

Suppress loading of HTML files.

This is useful when the only output from a page is intended to come from the PHP page file.

Parameters

  NewSetting | TRUE to suppress HTML output, FALSE to not suppress HTML output. (OPTIONAL, defaults to TRUE)

Definition at line 665 of file ApplicationFramework.php.

ApplicationFramework::TaskExecutionEnabled | ( |  | $NewValue = `NULL` | ) |

Get/set whether automatic task execution is enabled.

(This does not prevent tasks from being manually executed.)

Parameters

  bool | $NewValue | TRUE to enable or FALSE to disable.

Returns
  Returns TRUE if automatic task execution is enabled or otherwise FALSE.

Definition at line 1580 of file ApplicationFramework.php.

ApplicationFramework::TaskIsInQueue | ( |  | $Callback,
|  |  | $Parameters = `NULL`
| ) |  |

Check if task is already in queue or currently running.

When no $Parameters value is specified the task is checked against any other entries with the same $Callback.

Parameters

  callback | $Callback | Function or method to call to perform task.
  array | $Parameters | Array containing parameters to pass to function or method. (OPTIONAL)

Returns
  TRUE if task is already in queue, otherwise FALSE.

Definition at line 1410 of file ApplicationFramework.php.

Referenced by QueueUniqueTask().

Here is the caller graph for this function:

ApplicationFramework::TemplateLocationCacheExpirationInterval | ( |  | $NewInterval = `-1` | ) |

Get/set UI template location cache expiration period in minutes.

An expiration period of 0 disables caching.

Parameters

  int | $NewInterval | New expiration period in minutes. (OPTIONAL)

Returns
  Current expiration period in minutes.

Definition at line 287 of file ApplicationFramework.php.

## Member Data Documentation

const ApplicationFramework::EVENTTYPE_CHAIN = 2

Result chaining event type.

For this type the parameter array to each event handler is the return value from the previous handler, and the final return value is sent back to the event signaller.

Definition at line 1099 of file ApplicationFramework.php.

const ApplicationFramework::EVENTTYPE_DEFAULT = 1

Default event type.

Any handler return values are ignored.

Definition at line 1093 of file ApplicationFramework.php.

const ApplicationFramework::EVENTTYPE_FIRST = 3

First response event type.

For this type event handlers are called until one returns a non-NULL result, at which point no further handlers are called and that last result is passed back to the event signaller.

Definition at line 1105 of file ApplicationFramework.php.

const ApplicationFramework::EVENTTYPE_NAMED = 4

Named result event type.

Return values from each handler are placed into an array with the handler (function or class::method) name as the index, and that array is returned to the event signaller. The handler name for class methods is the class name plus "::" plus the method name. are called and that last result is passed back to the event signaller.

Definition at line 1113 of file ApplicationFramework.php.

const ApplicationFramework::LOGLVL_DEBUG = 5

DEBUG error logging leve.

Information that is diagnostically helpful when debugging.

Definition at line 1060 of file ApplicationFramework.php.

const ApplicationFramework::LOGLVL_ERROR = 2

ERROR error logging level.

Any error which is fatal to the operation currently being performed, but does not result in overall application shutdown or persistent data corruption.

Definition at line 1077 of file ApplicationFramework.php.

const ApplicationFramework::LOGLVL_FATAL = 1

FATAL error logging level.

Any error which results in overall application shutdown or persistent data corruption.

Definition at line 1082 of file ApplicationFramework.php.

const ApplicationFramework::LOGLVL_INFO = 4

INFO error logging level.

Generally-useful information, that may come in handy but to which little attention is normally paid. (This should not be used for events that routinely occur with every page load.)

Definition at line 1066 of file ApplicationFramework.php.

const ApplicationFramework::LOGLVL_TRACE = 6

TRACE error logging level.

Very detailed logging, usually only used when attempting to diagnose a problem in one specific section of code.

Definition at line 1055 of file ApplicationFramework.php.

const ApplicationFramework::LOGLVL_WARNING = 3

WARNING error logging level.

An event that may potentially cause problems, but is automatically recovered from.

Definition at line 1071 of file ApplicationFramework.php.

const ApplicationFramework::NOVALUE = ".-+-.NO VALUE PASSED IN FOR ARGUMENT.-+-."

Definition at line 2380 of file ApplicationFramework.php.

const ApplicationFramework::ORDER_FIRST = 1

Run hooked function first (i.e.

before ORDER_MIDDLE events).

Definition at line 1116 of file ApplicationFramework.php.

const ApplicationFramework::ORDER_LAST = 3

Run hooked function last (i.e.

after ORDER_MIDDLE events).

Definition at line 1120 of file ApplicationFramework.php.

Referenced by PluginManager\__construct().

const ApplicationFramework::ORDER_MIDDLE = 2

Run hooked function after ORDER_FIRST and before ORDER_LAST events.

Definition at line 1118 of file ApplicationFramework.php.

const ApplicationFramework::PRIORITY_BACKGROUND = 4

Lowest priority.

Definition at line 1330 of file ApplicationFramework.php.

const ApplicationFramework::PRIORITY_HIGH = 1

Highest priority.

Definition at line 1324 of file ApplicationFramework.php.

const ApplicationFramework::PRIORITY_LOW = 3

Lower priority.

Definition at line 1328 of file ApplicationFramework.php.

Referenced by SPTRecommender\RunUpdateForItem().

const ApplicationFramework::PRIORITY_MEDIUM = 2

Medium (default) priority.

Definition at line 1326 of file ApplicationFramework.php.

The documentation for this class was generated from the following file:

- lib/ScoutLib/ApplicationFramework.php